<?php

/**
 *   DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *                    Version 2, December 2004
 *
 * Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
 *
 * Everyone is permitted to copy and distribute verbatim or modified
 * copies of this license document, and changing it is allowed as long
 * as the name is changed.
 *
 *            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *
 *   0. You just DO WHAT THE FUCK YOU WANT TO.
 *
 * Auteur : kamui57 <kamui57@mailoo.org> alias Stéphanie Pleyer <stephanie.pleyer@mailoo.org>
 * cf http://forum.ubuntu-fr.org/viewtopic.php?pid=6126221
*/

/** Version 0.1.1
 *
 *  12/09/2011
 */

/** Fonctions pour l'affichage d'une galerie de smileys
 *
 *
 * TODO : - sélectionner les images en fonction du type mime et 
 * non pas de l'extension
 *
 */

/** Active ou désactive l'affichage des erreurs php selon le
 * paramètre DEBUG de config.php
 */
function debug(){
  require_once('config.php');
  ini_set('display_errors', DEBUG);
}


/** Fonction cherchant les images contenues dans un dossier
 * et stockant leurs informations dans un tableau
 * 
 *  Arguments : $path : chemin du dossier
 *              
 *  Retourne : tableau contenant pour chaque image
 *              - le chemin de l'original [url]
 *              - la taille [size]
 *              - le chemin de sa miniature [mini]
 *
 */
function load_images($path){
  
  require_once('config.php');
  $path=$path.'/';
  $ALLOWED_EXTENSIONS = unserialize(ALLOWED_EXTENSIONS);
  //var_dump( $ALLOWED_EXTENSIONS );
  // Test de l'existence du dossier
  if (!is_dir ($path)){
    echo ("Le dossier $path n'existe pas");
  }

  // Parcours du dossier et stockage des images et de leurs informations
  $dir = dir($path);
  while ($file = $dir->read()) {

    if (($file != '.') && ($file != 'CVS') && ($file != '..')) {
      $file_size = filesize($path . $file);
      $file_extension = file_ext($file);
      if(!is_dir($path . $file) && isset($file_extension) && in_array($file_extension,$ALLOWED_EXTENSIONS)) {

	// Création de la miniature si elle n'existe pas
	$mini_name = basename($file,'.'.$file_extension).'.png';
	$cheminmini=$path.MINI_DIR.$mini_name;
	if (!file_exists($path.MINI_DIR.$mini_name)){
	  $chemin=convert_resize($path,$file,$file_extension);
	}
	
	$images[] = array('chemin' => $path.$file,
			  'mini' => $cheminmini,
			  'size' => $file_size);
      }	
    }
  }
  return $images;
}

/** Fonction affichant les smileys contenus dans un dossier
 *  Arguments  : $path : chemin du dossier à partir de la page courante
 *
 */
function display_gallery($path){
  require_once('config.php');

  $images = load_images($path);
  $SMILEY_DIRS = unserialize(SMILEY_DIRS);

  // Vérification que le dossier contient des images
  $count = count($images);
  if ($count < 1){
    echo ("Pas d'images dans ce dossier $path dommage");
  }

  // On fait apparaître des éléments en javascript pour chaque galerie de 
  // smileys. Pour que la page fonctionne sans javascript, on cache les éléments
  // en javascript. Sans js activé, les smileys seront affichés.

  // On commence par cacher la galerie du dossier.
  $script_toggle = '<script type="text/javascript">  toggle(\''.basename($path).'\');';

  // Titre contenant le chemin du dossier sur lequel cliquer pour afficher la galerie.
  echo '<h2><a class="click" onclick="document.getElementById(\'codes\').innerHTML=\'\';toggle(\''.basename($path).'\');" href="#nogo" >'.$SMILEY_DIRS[basename($path)].'</a></h2>';echo "\n";

  // Début de la galerie pour le dossier
  echo '<div class="album" id="'.basename($path).'">';echo "\n";

  // On parcourt le tableau d'images
  for ($x=1; $x<=$count; $x++){
    if ($x <= $count){

      $id=basename($path).$x;
      $url = $images[$x -1]['chemin'];
      $url_mini = $images[$x -1]['mini'];
      // On cache en javascript les images originales
      $script_toggle.='    toggle(\''.$id.'\');';
      $texte="\'codes\'";

      include('smiley.php');

    }
  }

  // Sans cette div, le conteneur apparaît vide à cause du positionnement
  // flottant des smileys
  echo '	  <div style="clear:both;"></div>';

  // Fin de la galerie pour ce dossier
  echo '        </div>';echo "\n";
  
  // On termine le script qui cache les éléments et on l'affiche
  $script_toggle.='</script>';
  echo $script_toggle;echo "\n";
}

  //function to get file extension of files
  function file_ext($file) {
    $extension = split("[.]", $file);
    $ext_file = $extension[count($extension)-1];
    return strtolower($ext_file);
  }

/** Returns the different paths of all subdirectories of the folder
 * containing them.
 * Argument : the name of the folder containing the albums. It must be 
 * on root of the website.
 */
function get_images_directories($images_directory){

  if (!is_dir ($images_directory)){
    die("Le dossier $images_directory n'existe pas");
  }
  $dir = dir($images_directory);
  while ($file = $dir->read()) {
    if (($file != '.')  && ($file != '..')) {
      if(is_dir($images_directory.'/'.$file)) {
	$albums[] = $file;
      } 

    }

    
  }
  return $albums;
}

/** Miniaturise une image.
 *  Arguments : $path : dossier de l'image
 *              $image_filename : nom de fichier de l'image
 *              $file_extension : extension de l'image
 *
 *  TODO : se baser sur les types mime et non plus sur les extensions
 *  Source http://www.uploadify.com/forums/discussion/5004/resize-php-script-working-for-png-and-gif-too./p1
 */

function convert_resize($path,$image_filename,$file_extension){
  require_once('config.php');
  $MAX_MINI_DIMENSIONS = unserialize(MAX_MINI_DIMENSIONS);
  $width = $MAX_MINI_DIMENSIONS['width'];
  $height = $MAX_MINI_DIMENSIONS['height'];

  
  if ($width == 0){
    die ("Largeur maximale nulle");
  }

  if ($height == 0){
    die ("Largeur maximale nulle");
  }

  list($width_orig, $height_orig) = getimagesize($path.$image_filename);

  if (($width_orig <= $width)&&($height_orig <= $height)){
      $width = $width_orig;
      $height = $height_orig;
    }
  else
    {
      $ratio_orig = $width_orig/$height_orig;

      if ($width/$height > $ratio_orig) {
	$width = $height*$ratio_orig;
      } else {
	$height = $width/$ratio_orig;
      }
    }
  $image_p = imagecreatetruecolor($width, $height);
  $mini_name = basename($image_filename,'.'.$file_extension).'.png';

  //echo "Extension : ".$file_extension;

  switch ($file_extension) {

  case "gif":
    
    if (!file_exists($path.MINI_DIR.$mini_name)){
      //echo "<p>Création de ".$path.MINI_DIR.$mini_name." à partir de ".$path.$image_filename."</p>";
      if (!file_exists($path.$image_filename)){
	echo "Le fichier ".$path.$image_filename." n'existe pas";
	break;
      }
      $image = imagecreatefromgif($path.$image_filename);
      // fond transparent (pour les gifs avec transparence)
      $red = rand(0,255);
      $green = rand(0,255);
      $blue = rand(0,255);
      $transparent = imagecolorallocate($image_p, $red, $green, $blue);
      imagefill($image_p, 0, 0, $transparent);
      imagecolortransparent($image_p, $transparent);
      imagetruecolortopalette($image_p, false, 256);
    }
    break;

  case "png":
   
    if (!file_exists($path.MINI_DIR.$mini_name)){
      //echo "<p>Création de ".$path.MINI_DIR.$mini_name." à partir de ".$path.$image_filename."</p>";
      if (!file_exists($path.$image_filename)){
	echo "Le fichier ".$path.$image_filename." n'existe pas";
	break;
      }
      $image = imagecreatefrompng($path.$image_filename);
	
      // fond transparent (pour les png avec transparence)
      imagesavealpha($image_p, true);
      $trans_color = imagecolorallocatealpha($image_p, 0, 0, 0, 127);
      imagefill($image_p, 0, 0, $trans_color);
    }
    break;

  case "jpg":
    if (!file_exists($path.MINI_DIR.$mini_name)){
    
      //echo "<p>Création de ".$path.MINI_DIR.$mini_name." à partir de ".$path.$image_filename."</p>";
      if (!file_exists($path.$image_filename)){
	echo "Le fichier ".$path.$image_filename." n'existe pas";
	break;
      }
      $image = imagecreatefromjpeg($path.$image_filename);
    }
    break;
  }


  imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
  imagepng($image_p,$path.MINI_DIR.$mini_name);
  $chemin['mini'] = $path.MINI_DIR.$mini_name;
  return $chemin;

}

  ?>